//
// argcgv.cpp : Defines the entry point for the console application.
// A C++ program using an array of pointers to process
// the command-line arguments argc, argv
// Copyright (c) Chris H. Pappas and William H. Murray, 2001
//

#include <iostream>
#include <cstdlib>      // exit( ), atoi( )
using namespace std;

#define IFIND_LARGEST 1
#define IFIND_SMALLEST 0

int main(int argc, char *argv[])
{
  char *psz;
  int ihow_many;
  int iwhich_extreme = 0;
  int irange_boundary = 32767;

  if(argc < 2) {
    cout << "\nYou need to enter an -S,-s,-L,-l"
         << " and at least one integer value ";
    exit(1);
  }

  while(--argc > 0 && (*++argv)[0] == '-') {
    for(psz = argv[0]+1; *psz != '\0'; psz++) {
      switch(*psz) {
        case 's':
        case 'S':
          iwhich_extreme = IFIND_SMALLEST;
          irange_boundary = 32767;
          break;
        case 'l':
        case 'L':
          iwhich_extreme = IFIND_LARGEST;
          irange_boundary = 0;
          break;
        default:
          cout << "unknown argument "<< *psz << endl;
          exit(1);
      }
    }
  }

  if(argc==0) {
    cout << "Please enter at least one number\n";
    exit(1);
  }

  ihow_many=argc;

  while(argc--) {
    int present_value;
    present_value = atoi(*(argv++));
    if(iwhich_extreme == IFIND_LARGEST && present_value >
       irange_boundary)
      irange_boundary=present_value;
    if(iwhich_extreme == IFIND_SMALLEST && present_value <
       irange_boundary)
      irange_boundary=present_value;
  }

  cout << "The ";
  cout << ((iwhich_extreme) ? "largest" : "smallest");
  cout << " of the " << ihow_many << " value(s) input is " <<
          irange_boundary << endl;

  return(0);
}
